public class DynArrayIntList implements IntList {
  private final static int DEFAULT_CAPACITY = 10;

  private int[] a = null;
  private int size = 0;

  public DynArrayIntList() {
    a = new int[DEFAULT_CAPACITY];
  }

  public DynArrayIntList(int initialCapacity) {
    a = new int[initialCapacity];
  }

  public void add(int e) {
    add(size, e);
  }

  public void add(int index, int e) {
    if (index < 0 || index > size) {
      throw new IndexOutOfBoundsException();
    }
    if (size == a.length) growArray();

    for (int i = size; i > index; i--) {
      a[i] = a[i - 1];
    }
    a[index] = e;
    size++;
  }
  
  private void growArray() {
    int[] b = new int[a.length * 2];
    
    for (int i = 0; i < size; i++) {
      b[i] = a[i];
    }
    
    a = b;
  }

  public void remove(int index) {
    if (index < 0 || index >= size) {
      throw new IndexOutOfBoundsException();
    }
    
    size--;
    for (int i = index; i < size; i++) {
      a[i] = a[i + 1];
    }
  }

  public void clear() {
    size = 0;
  }

  public int get(int index) {
    if (index < 0 || index >= size) {
      throw new IndexOutOfBoundsException();
    }

    return a[index];    
  }
  public void set(int index, int e) {
    if (index < 0 || index >= size) {
      throw new IndexOutOfBoundsException();
    }

    a[index] = e;    
  }
  public int size() {
    return size;
  }
}